clear all;close all;
str1=datestr(now,30);

jg = 0;
f = figure(5);
jb = uicontrol('style','push','string','stop','callback','jg=jg+1');
size = 1000000;

parity_bits=1; % pocet paritnich bitu
ber1 = logspace(-9,-0.8,1001);
db1  = 20*log10(erfinv(1-2*ber1));


%3D2L
dimension1=3; % pocet dimenzi paritniho kodu
block_depth1=2; % delka strany bloku dat
R1=(block_depth1^dimension1)/((block_depth1+parity_bits)^dimension1);
ebno1=[3 3.25 3.5 3.75 4 4.25];
filename1=strcat('3D2L_bp_BerFerValue.mat');
data1 = matfile(filename1);

%4D3L
dimension2=4; % pocet dimenzi paritniho kodu
block_depth2=3; % delka strany bloku dat
R2=(block_depth2^dimension2)/((block_depth2+parity_bits)^dimension2);
ebno2=[0.25 0.75 1.25 1.75 2.25 2.75];
filename2=strcat('4D3L_bp_BerFerValue.mat');
data2 = matfile(filename2);

%5D4L
dimension3=5; % pocet dimenzi paritniho kodu
block_depth3=4; % delka strany bloku dat
R3=(block_depth3^dimension3)/((block_depth3+parity_bits)^dimension3);
ebno3=[0.25 0.75 1.25 1.75];
filename3=strcat('5D4L_bp_BerFerValue.mat');
data3 = matfile(filename3);

%6D5L
dimension4=6; % pocet dimenzi paritniho kodu
block_depth4=5; % delka strany bloku dat
R4=(block_depth4^dimension4)/((block_depth4+parity_bits)^dimension4);
ebno4=[-1.75 -1.25 -0.75 -0.25];
filename4=strcat('6D5L_bp_BerFerValue.mat');
data4 = matfile(filename4);

%3D4L
dimension5=3; % pocet dimenzi paritniho kodu
block_depth5=4; % delka strany bloku dat
R5=(block_depth5^dimension5)/((block_depth5+parity_bits)^dimension5);
ebno5=[2.95 3.25 3.5 3.75 4 4.25 4.55 4.8];
filename5=strcat('3D4L_bp_BerFerValue.mat');
data5 = matfile(filename5);

%4D5L
dimension6=4; % pocet dimenzi paritniho kodu
block_depth6=5; % delka strany bloku dat
R6=(block_depth6^dimension6)/((block_depth6+parity_bits)^dimension6);
ebno6=[1.25 1.5 1.75 2 2.25 2.5 2.8 3.1];
filename6=strcat('4D5L_bp_BerFerValue.mat');
data6 = matfile(filename6);


%3D2L
BER_1_3D2L=single(data1.error_number_1)./data1.p;
FER_1_3D2L=single(data1.frame_error_1)./data1.frame_number;
UFER_1_3D2L=single(data1.not_det1)./data1.frame_number;

BER_2_3D2L=single(data1.error_number_2)./data1.p;
FER_2_3D2L=single(data1.frame_error_2)./data1.frame_number;
UFER_2_3D2L=single(data1.not_det2)./data1.frame_number;

BER_3_3D2L=single(data1.error_number_3)./data1.p;
FER_3_3D2L=single(data1.frame_error_3)./data1.frame_number;
UFER_3_3D2L=single(data1.not_det3)./data1.frame_number;

%4D3L
BER_1_4D3L=single(data2.error_number_1)./data2.p;
FER_1_4D3L=single(data2.frame_error_1)./data2.frame_number;
UFER_1_4D3L=single(data2.not_det1)./data2.frame_number;

BER_2_4D3L=single(data2.error_number_2)./data2.p;
FER_2_4D3L=single(data2.frame_error_2)./data2.frame_number;
UFER_2_4D3L=single(data2.not_det2)./data2.frame_number;

BER_3_4D3L=single(data2.error_number_3)./data2.p;
FER_3_4D3L=single(data2.frame_error_3)./data2.frame_number;
UFER_3_4D3L=single(data2.not_det3)./data2.frame_number;

%5D4L
BER_1_5D4L=single(data3.error_number_1)./data3.p;
FER_1_5D4L=single(data3.frame_error_1)./data3.frame_number;
UFER_1_5D4L=single(data3.not_det1)./data3.frame_number;

BER_2_5D4L=single(data3.error_number_2)./data3.p;
FER_2_5D4L=single(data3.frame_error_2)./data3.frame_number;
UFER_2_5D4L=single(data3.not_det2)./data3.frame_number;

BER_3_5D4L=single(data3.error_number_3)./data3.p;
FER_3_5D4L=single(data3.frame_error_3)./data3.frame_number;
UFER_3_5D4L=single(data3.not_det3)./data3.frame_number;

%6D5L
BER_1_6D5L=single(data4.error_number_1)./data4.p;
FER_1_6D5L=single(data4.frame_error_1)./data4.frame_number;
UFER_1_6D5L=single(data4.not_det1)./data4.frame_number;

BER_2_6D5L=single(data4.error_number_2)./data4.p;
FER_2_6D5L=single(data4.frame_error_2)./data4.frame_number;
UFER_2_6D5L=single(data4.not_det2)./data4.frame_number;

BER_3_6D5L=single(data4.error_number_3)./data4.p;
FER_3_6D5L=single(data4.frame_error_3)./data4.frame_number;
UFER_3_6D5L=single(data4.not_det3)./data4.frame_number;

%3D4L
BER_1_3D4L=single(data5.error_number_1)./data5.p;
FER_1_3D4L=single(data5.frame_error_1)./data5.frame_number;
UFER_1_3D4L=single(data5.not_det1)./data5.frame_number;

BER_2_3D4L=single(data5.error_number_2)./data5.p;
FER_2_3D4L=single(data5.frame_error_2)./data5.frame_number;
UFER_2_3D4L=single(data5.not_det2)./data5.frame_number;

BER_3_3D4L=single(data5.error_number_3)./data5.p;
FER_3_3D4L=single(data5.frame_error_3)./data5.frame_number;
UFER_3_3D4L=single(data5.not_det3)./data5.frame_number;

%4D5L
BER_1_4D5L=single(data6.error_number_1)./data6.p;
FER_1_4D5L=single(data6.frame_error_1)./data6.frame_number;
UFER_1_4D5L=single(data6.not_det1)./data6.frame_number;

BER_2_4D5L=single(data6.error_number_2)./data6.p;
FER_2_4D5L=single(data6.frame_error_2)./data6.frame_number;
UFER_2_4D5L=single(data6.not_det2)./data6.frame_number;

BER_3_4D5L=single(data6.error_number_3)./data6.p;
FER_3_4D5L=single(data6.frame_error_3)./data6.frame_number;
UFER_3_4D5L=single(data6.not_det3)./data6.frame_number;

figure(5);
%{
%Hodnoty UFER 1/3
semilogy(ebno1+10*log10(1/R1),UFER_1_3D2L,'-r',ebno1+10*log10(1/R1),UFER_2_3D2L,'--r',ebno1+10*log10(1/R1),UFER_3_3D2L,'.-r');
%legend('BER_R_E_F','BER-3D2L_1','BER-3D2L_2','BER-3D2L_3');
hold on;
semilogy(ebno2+10*log10(1/R2),UFER_1_4D3L,'-b',ebno2+10*log10(1/R2),UFER_2_4D3L,'--b',ebno2+10*log10(1/R2),UFER_3_4D3L,'.-b');
%legend('BER-4D3L_1','BER-4D3L_2','BER-4D3L_3');
hold on;
semilogy(ebno3+10*log10(1/R3),UFER_1_5D4L,'-g',ebno3+10*log10(1/R3),UFER_2_5D4L,'--g',ebno3+10*log10(1/R3),UFER_3_5D4L,'.-g');
%legend('BER-5D4L_1','BER-5D4L_2','BER-5D4L_3');
hold on;
semilogy(ebno4+10*log10(1/R4),UFER_1_6D5L,'-k',ebno4+10*log10(1/R4),UFER_2_6D5L,'--k',ebno4+10*log10(1/R4),UFER_3_6D5L,'.-k');
%legend('BER-6D5L_1','BER-6D5L_2','BER-6D5L_3');
hold on;
legend('UFER-3D2L_1','UFER-3D2L_2','UFER-3D2L_3','UFER-4D3L_1','UFER-4D3L_2','UFER-4D3L_3','UFER-5D4L_1','UFER-5D4L_2','UFER-5D4L_3','UFER-6D5L_1','UFER-6D5L_2','UFER-6D5L_3');
xlabel('Eb/No [dB]');
ylabel('UFER [-]');

%}

%{
%Hodnoty UFER 1/2
semilogy(ebno5+10*log10(1/R5),UFER_1_3D4L,'-r',ebno5+10*log10(1/R5),UFER_2_3D4L,'--r',ebno5+10*log10(1/R5),UFER_3_3D4L,'.-r');
hold on;
semilogy(ebno6+10*log10(1/R6),UFER_1_4D5L,'-b',ebno6+10*log10(1/R6),UFER_2_4D5L,'--b',ebno6+10*log10(1/R6),UFER_3_4D5L,'.-b');
hold on;
legend('UFER-3D4L_1','UFER-3D4L_2','UFER-3D4L_3','UFER-4D5L_1','UFER-4D5L_2','UFER-4D5L_3');
xlabel('Eb/No [dB]');
ylabel('UFER [-]');
%}


%{
%Hodnoty FER 1/3
semilogy(ebno1+10*log10(1/R1),FER_1_3D2L,'-r',ebno1+10*log10(1/R1),FER_2_3D2L,'--r',ebno1+10*log10(1/R1),FER_3_3D2L,'.-r');
%legend('BER_R_E_F','BER-3D2L_1','BER-3D2L_2','BER-3D2L_3');
hold on;
semilogy(ebno2+10*log10(1/R2),FER_1_4D3L,'-b',ebno2+10*log10(1/R2),FER_2_4D3L,'--b',ebno2+10*log10(1/R2),FER_3_4D3L,'.-b');
%legend('BER-4D3L_1','BER-4D3L_2','BER-4D3L_3');
hold on;
semilogy(ebno3+10*log10(1/R3),FER_1_5D4L,'-g',ebno3+10*log10(1/R3),FER_2_5D4L,'--g',ebno3+10*log10(1/R3),FER_3_5D4L,'.-g');
%legend('BER-5D4L_1','BER-5D4L_2','BER-5D4L_3');
hold on;
semilogy(ebno4+10*log10(1/R4),FER_1_6D5L,'-k',ebno4+10*log10(1/R4),FER_2_6D5L,'--k',ebno4+10*log10(1/R4),FER_3_6D5L,'.-k');
%legend('BER-6D5L_1','BER-6D5L_2','BER-6D5L_3');
hold on;
legend('FER-3D2L_1','FER-3D2L_2','FER-3D2L_3','FER-4D3L_1','FER-4D3L_2','FER-4D3L_3','FER-5D4L_1','FER-5D4L_2','FER-5D4L_3','FER-6D5L_1','FER-6D5L_2','FER-6D5L_3');
xlabel('Eb/No [dB]');
ylabel('FER [-]');

%}

%{
%Hodnoty FER 1/2
semilogy(ebno5+10*log10(1/R5),FER_1_3D4L,'-r',ebno5+10*log10(1/R5),FER_2_3D4L,'--r',ebno5+10*log10(1/R5),FER_3_3D4L,'.-r');
%legend('FER-3D4L_1','FER-3D4L_2','FER-3D4L_3');
hold on;
semilogy(ebno6+10*log10(1/R6),FER_1_4D5L,'-b',ebno6+10*log10(1/R6),FER_2_4D5L,'--b',ebno6+10*log10(1/R6),FER_3_4D5L,'.-b');
%legend('FER-4D5L_1','FER-4D5L_2','FER-4D5L_3');
hold on;
legend('FER-3D4L_1','FER-3D4L_2','FER-3D4L_3','FER-4D5L_1','FER-4D5L_2','FER-4D5L_3');
xlabel('Eb/No [dB]');
ylabel('FER [-]');
%}


%{
%Hodnoty BER 1/3
semilogy(db1,ber1,'y',ebno1+10*log10(1/R1),BER_1_3D2L,'-r',ebno1+10*log10(1/R1),BER_2_3D2L,'--r',ebno1+10*log10(1/R1),BER_3_3D2L,'.-r');
%legend('BER_R_E_F','BER-3D2L_1','BER-3D2L_2','BER-3D2L_3');
hold on;
semilogy(ebno2+10*log10(1/R2),BER_1_4D3L,'-b',ebno2+10*log10(1/R2),BER_2_4D3L,'--b',ebno2+10*log10(1/R2),BER_3_4D3L,'.-b');
%legend('BER-4D3L_1','BER-4D3L_2','BER-4D3L_3');
hold on;
semilogy(ebno3+10*log10(1/R3),BER_1_5D4L,'-g',ebno3+10*log10(1/R3),BER_2_5D4L,'--g',ebno3+10*log10(1/R3),BER_3_5D4L,'.-g');
%legend('BER-5D4L_1','BER-5D4L_2','BER-5D4L_3');
hold on;
semilogy(ebno4+10*log10(1/R4),BER_1_6D5L,'-k',ebno4+10*log10(1/R4),BER_2_6D5L,'--k',ebno4+10*log10(1/R4),BER_3_6D5L,'.-k');
%legend('BER-6D5L_1','BER-6D5L_2','BER-6D5L_3');
hold on;
legend('BER_R_E_F','BER-3D2L_1','BER-3D2L_2','BER-3D2L_3','BER-4D3L_1','BER-4D3L_2','BER-4D3L_3','BER-5D4L_1','BER-5D4L_2','BER-5D4L_3','BER-6D5L_1','BER-6D5L_2','BER-6D5L_3');
xlabel('Eb/No [dB]');
ylabel('FER [-]');
%}

%{
%Hodnoty BER 1/2
semilogy(db1,ber1,'y',ebno5+10*log10(1/R5),BER_1_3D4L,'-r',ebno5+10*log10(1/R5),BER_2_3D4L,'--r',ebno5+10*log10(1/R5),BER_3_3D4L,'.-r');
%legend('BER-3D4L_1','BER-3D4L_2','BER-3D4L_3');
hold on;
semilogy(ebno6+10*log10(1/R6),BER_1_4D5L,'-b',ebno6+10*log10(1/R6),BER_2_4D5L,'--b',ebno6+10*log10(1/R6),BER_3_4D5L,'.-b');
%legend('BER-4D5L_1','BER-4D5L_2','BER-4D5L_3');
hold on;
legend('BER_R_E_F','BER-3D4L_1','BER-3D4L_2','BER-3D4L_3','BER-4D5L_1','BER-4D5L_2','BER-4D5L_3');
xlabel('Eb/No [dB]');
ylabel('BER [-]');
%}

%{
%Coding Gain 5D4L
semilogy(db1,ber1,'y',ebno3+10*log10(1/R3),BER_1_5D4L,'-b');
hold on;
horizontal = line([6.595500650402820 10.754137992858887],[5.303822945279535e-07 5.303822945279535e-07]);
horizontal.Color = 'red';
horizontal.Marker = 'o';
legend('BER_R_E_F','BER-5D4L_1','Coding Gain');
%plot(0,5,'-k');
xlabel('Eb/No [dB]');
ylabel('BER [-]');
%}


